﻿Public Class Form2

    Private MeterAspect As Double
    Private OldSize As Size

    Private Sub Form2_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        DragEnabled = True
        TestSnap()
        SetMeterScale()
        MeterAspect = AnalogMeter1.Width / AnalogMeter1.Height
        OldSize = Me.Size
        SetAspectRatio()
        MeterTimer.Interval = 30
        MeterTimer.Start()
    End Sub

    Private Sub Form2_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Save_INI()
        Me.Hide()
        e.Cancel = True
    End Sub

    ' --------------------------------------------------------------------- 
    ' BUTTONS
    ' --------------------------------------------------------------------- 
    Private Sub btn_CPS_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_CPS.ClickButtonArea
        btn_CPM.Checked = False
        btn_SievertCurie.Checked = False
        btn_RoentgenBequerel.Checked = False
        SetMeterScale()
    End Sub
    Private Sub btn_CPM_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_CPM.ClickButtonArea
        btn_CPS.Checked = False
        btn_SievertCurie.Checked = False
        btn_RoentgenBequerel.Checked = False
        SetMeterScale()
    End Sub

    Private Sub btn_Sh_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_SievertCurie.ClickButtonArea
        btn_CPM.Checked = False
        btn_CPS.Checked = False
        btn_RoentgenBequerel.Checked = False
        SetMeterScale()
    End Sub
    Private Sub btn_Rh_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_RoentgenBequerel.ClickButtonArea
        btn_CPM.Checked = False
        btn_CPS.Checked = False
        btn_SievertCurie.Checked = False
        SetMeterScale()
    End Sub

    Private Sub btn_Low_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_Low.ClickButtonArea
        btn_Mid.Checked = False
        btn_Hi.Checked = False
        SetMeterScale()
    End Sub
    Private Sub btn_Mid_ClickButtonArea(ByVal Sender As Object, ByVal e As System.EventArgs) Handles btn_Mid.ClickButtonArea
        btn_Low.Checked = False
        btn_Hi.Checked = False
        SetMeterScale()
    End Sub
    Private Sub btn_Hi_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_Hi.ClickButtonArea
        btn_Low.Checked = False
        btn_Mid.Checked = False
        SetMeterScale()
    End Sub

    Private Sub btn_Slow_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_Slow.ClickButtonArea
        m_kspeed = SPEED_SLOW
        SetButtonStates()
    End Sub
    Private Sub btn_Norm_ClickButtonArea(ByVal Sender As Object, ByVal e As System.EventArgs) Handles btn_Norm.ClickButtonArea
        m_kspeed = SPEED_NORM
        SetButtonStates()
    End Sub
    Private Sub btn_Fast_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_Fast.ClickButtonArea
        m_kspeed = SPEED_FAST
        SetButtonStates()
    End Sub

    Friend Enum ScaleTypes As Int32
        CpsLow
        CpsMid
        CpsHi
        '
        CpmLow
        CpmMid
        CpmHi
        '
        ShLow
        ShMid
        ShHi
        '
        RhLow
        RhMid
        RhHi
        '
        CiLow
        CiMid
        CiHi
        '
        BqLow
        BqMid
        BqHi
    End Enum
    Private m_ScaleType As ScaleTypes

    Private Sub ComputeScaleTypeFromButtons()
        If btn_CPS.Checked Then m_ScaleType = ScaleTypes.CpsLow
        If btn_CPM.Checked Then m_ScaleType = ScaleTypes.CpmLow
        Select Case RollingGraph_MeasureUnit
            Case "Sievert", "Roentgen"
                If btn_SievertCurie.Checked Then m_ScaleType = ScaleTypes.ShLow
                If btn_RoentgenBequerel.Checked Then m_ScaleType = ScaleTypes.RhLow
            Case Else
                If btn_SievertCurie.Checked Then m_ScaleType = ScaleTypes.CiLow
                If btn_RoentgenBequerel.Checked Then m_ScaleType = ScaleTypes.BqLow
        End Select
        If btn_Mid.Checked Then m_ScaleType = CType(m_ScaleType + 1, ScaleTypes)
        If btn_Hi.Checked Then m_ScaleType = CType(m_ScaleType + 2, ScaleTypes)
    End Sub

    Friend Sub SetScaleType(ByVal n As Int32)
        m_ScaleType = CType(n, ScaleTypes)
        SetButtonStates()
        SetMeterScale()
    End Sub

    Friend Function GetScaleType() As Int32
        Return m_ScaleType
    End Function

    Friend Sub SetMeterSpeed(ByVal n As Single)
        m_kspeed = n
        SetButtonStates()
    End Sub

    Friend Function GetMeterSpeed() As Single
        Return m_kspeed
    End Function

    Friend Sub SetMeterScale()
        ComputeScaleTypeFromButtons()
        With AnalogMeter1
            Select Case m_ScaleType
                Case ScaleTypes.CpsLow
                    .ScaleText = "CPS"
                    .MinValue = 0
                    .MaxValue = 5
                    .TickLargeFrequency = 1
                    .TickSmallFrequency = 0.5
                    .TickTinyFrequency = 0.1
                    .TickLargeSize = 20
                    .TickSmallSize = 15
                    .LinearScale = True
                Case ScaleTypes.CpsMid
                    .ScaleText = "CPS"
                    .MinValue = 0
                    .MaxValue = 50
                    .TickLargeFrequency = 10
                    .TickSmallFrequency = 5
                    .TickTinyFrequency = 1
                    .TickLargeSize = 20
                    .TickSmallSize = 15
                    .LinearScale = True
                Case ScaleTypes.CpsHi
                    .ScaleText = "CPS"
                    .MinValue = 0
                    .MaxValue = 5000
                    .TickLargeFrequency = 1000
                    .TickSmallFrequency = 500
                    .TickTinyFrequency = 100
                    .TickLargeSize = 20
                    .TickSmallSize = 15
                    .LinearScale = True

                Case ScaleTypes.CpmLow
                    .ScaleText = "CPM"
                    .MinValue = 0
                    .MaxValue = 500
                    .TickLargeFrequency = 100
                    .TickSmallFrequency = 50
                    .TickTinyFrequency = 10
                    .TickLargeSize = 20
                    .TickSmallSize = 15
                    .LinearScale = True
                Case ScaleTypes.CpmMid
                    .ScaleText = "CPM"
                    .MinValue = 0
                    .MaxValue = 5000
                    .TickLargeFrequency = 1000
                    .TickSmallFrequency = 500
                    .TickTinyFrequency = 100
                    .TickLargeSize = 20
                    .TickSmallSize = 15
                    .LinearScale = True
                Case ScaleTypes.CpmHi
                    .ScaleText = "CPM"
                    .MinValue = 0
                    .MaxValue = 50000
                    .TickLargeFrequency = 10000
                    .TickSmallFrequency = 5000
                    .TickTinyFrequency = 1000
                    .TickLargeSize = 20
                    .TickSmallSize = 15
                    .LinearScale = True

                Case ScaleTypes.ShLow
                    .ScaleText = "uS/h"
                    .MinValue = 0.01
                    .MaxValue = 10
                    .TickLargeSize = 15
                    .TickSmallSize = 9
                    .LinearScale = False
                Case ScaleTypes.ShMid
                    .ScaleText = "uS/h"
                    .MinValue = 0.01
                    .MaxValue = 100
                    .TickLargeSize = 15
                    .TickSmallSize = 9
                    .LinearScale = False
                Case ScaleTypes.ShHi
                    .ScaleText = "uS/h"
                    .MinValue = 0.01
                    .MaxValue = 10000
                    .TickLargeSize = 15
                    .TickSmallSize = 9
                    .LinearScale = False

                Case ScaleTypes.RhLow
                    .ScaleText = "uR/h"
                    .MinValue = 1
                    .MaxValue = 1000
                    .TickLargeSize = 15
                    .TickSmallSize = 9
                    .LinearScale = False
                Case ScaleTypes.RhMid
                    .ScaleText = "uR/h"
                    .MinValue = 1
                    .MaxValue = 10000
                    .TickLargeSize = 15
                    .TickSmallSize = 9
                    .LinearScale = False
                Case ScaleTypes.RhHi
                    .ScaleText = "mR/h"
                    .MinValue = 0.001
                    .MaxValue = 1000
                    .TickLargeSize = 15
                    .TickSmallSize = 9
                    .LinearScale = False

                Case ScaleTypes.CiLow
                    .ScaleText = "pCi/l"
                    .MinValue = 0.01
                    .MaxValue = 10
                    .TickLargeSize = 15
                    .TickSmallSize = 9
                    .LinearScale = False
                Case ScaleTypes.CiMid
                    .ScaleText = "pCi/l"
                    .MinValue = 0.01
                    .MaxValue = 100
                    .TickLargeSize = 15
                    .TickSmallSize = 9
                    .LinearScale = False
                Case ScaleTypes.CiHi
                    .ScaleText = "pCi/l"
                    .MinValue = 0.01
                    .MaxValue = 10000
                    .TickLargeSize = 15
                    .TickSmallSize = 9
                    .LinearScale = False

                Case ScaleTypes.BqLow
                    .ScaleText = "Bq/m3"
                    .MinValue = 1
                    .MaxValue = 1000
                    .TickLargeSize = 15
                    .TickSmallSize = 9
                    .LinearScale = False
                Case ScaleTypes.BqMid
                    .ScaleText = "Bq/m3"
                    .MinValue = 1
                    .MaxValue = 10000
                    .TickLargeSize = 15
                    .TickSmallSize = 9
                    .LinearScale = False
                Case ScaleTypes.BqHi
                    .ScaleText = "Bq/m3"
                    .MinValue = 1
                    .MaxValue = 1000000
                    .TickLargeSize = 15
                    .TickSmallSize = 9
                    .LinearScale = False
            End Select
        End With
    End Sub

    Private Sub SetButtonStates()
        Select Case m_ScaleType
            Case ScaleTypes.CpsLow
                btn_CPS.Checked = True
                btn_Low.Checked = True
            Case ScaleTypes.CpsMid
                btn_CPS.Checked = True
                btn_Mid.Checked = True
            Case ScaleTypes.CpsHi
                btn_CPS.Checked = True
                btn_Hi.Checked = True
            Case ScaleTypes.CpmLow
                btn_CPM.Checked = True
                btn_Low.Checked = True
            Case ScaleTypes.CpmMid
                btn_CPM.Checked = True
                btn_Mid.Checked = True
            Case ScaleTypes.CpmHi
                btn_CPM.Checked = True
                btn_Hi.Checked = True

            Case ScaleTypes.ShLow
                btn_SievertCurie.Checked = True
                btn_Low.Checked = True
            Case ScaleTypes.ShMid
                btn_SievertCurie.Checked = True
                btn_Mid.Checked = True
            Case ScaleTypes.ShHi
                btn_SievertCurie.Checked = True
                btn_Hi.Checked = True
            Case ScaleTypes.RhLow
                btn_RoentgenBequerel.Checked = True
                btn_Low.Checked = True
            Case ScaleTypes.RhMid
                btn_RoentgenBequerel.Checked = True
                btn_Mid.Checked = True
            Case ScaleTypes.RhHi
                btn_RoentgenBequerel.Checked = True
                btn_Hi.Checked = True

            Case ScaleTypes.CiLow
                btn_SievertCurie.Checked = True
                btn_Low.Checked = True
            Case ScaleTypes.CiMid
                btn_SievertCurie.Checked = True
                btn_Mid.Checked = True
            Case ScaleTypes.CiHi
                btn_SievertCurie.Checked = True
                btn_Hi.Checked = True
            Case ScaleTypes.BqLow
                btn_RoentgenBequerel.Checked = True
                btn_Low.Checked = True
            Case ScaleTypes.BqMid
                btn_RoentgenBequerel.Checked = True
                btn_Mid.Checked = True
            Case ScaleTypes.BqHi
                btn_RoentgenBequerel.Checked = True
                btn_Hi.Checked = True
        End Select
        If m_kspeed = SPEED_SLOW Then
            btn_Slow.Checked = True
            btn_Norm.Checked = False
            btn_Fast.Checked = False
        ElseIf m_kspeed = SPEED_NORM Then
            btn_Slow.Checked = False
            btn_Norm.Checked = True
            btn_Fast.Checked = False
        Else
            btn_Slow.Checked = False
            btn_Norm.Checked = False
            btn_Fast.Checked = True
        End If
    End Sub


    ' --------------------------------------------------------------------- MOVE BY MOUSE
    Private CursorStartPos As Point
    Private FormStartPos As Point
    Private DragEnabled As Boolean = False

    Private Sub Form2_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        DragEnabled = True
        CursorStartPos = Cursor.Position
        FormStartPos = Me.Location
    End Sub
    Private Sub Form2_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        If Not DragEnabled Then Return
        If e.Button = Windows.Forms.MouseButtons.Left Then
            Me.Location = New Point(FormStartPos.X + Cursor.Position.X - CursorStartPos.X, _
                                    FormStartPos.Y + Cursor.Position.Y - CursorStartPos.Y)
        End If
    End Sub
    Private Sub AnalogMeter1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles AnalogMeter1.MouseDown
        Form2_MouseDown(sender, e)
    End Sub
    Private Sub AnalogMeter1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles AnalogMeter1.MouseMove
        Form2_MouseMove(sender, e)
    End Sub
    Private Sub Panel1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel1.MouseDown
        Form2_MouseDown(sender, e)
    End Sub
    Private Sub Panel1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Panel1.MouseMove
        Form2_MouseMove(sender, e)
    End Sub

    Private Sub Form2_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Move
        If Not DragEnabled Then Return
        LimitFormPosition(Me)
        TestSnap()
    End Sub


    ' --------------------------------------------------------------------- SNAP
    Private Snap As Int32 = 0
    Private Sub TestSnap()
        Dim newSnap As Int32 = 0
        '
        If Math.Abs(Me.Right - Form1.Right + 4) < 40 And Math.Abs(Me.Top - Form1.Top - 34) < 40 Then
            newSnap = 1
        End If
        '
        Dim p As Point = Form1.GroupBox_RadiationPlot.PointToScreen(Form1.pbox_ScrollingScope.Location)
        If Math.Abs(Me.Left - p.X - 4) < 40 And _
            Math.Abs(Me.Top - p.Y - 4) < 40 Then
            newSnap = 2
        End If
        '
        If newSnap <> Snap Then
            Snap = newSnap
            If newSnap <> 0 Then
                DragEnabled = False
                SetSnap()
            End If
        End If
    End Sub

    Friend Sub SetSnap()
        Select Case Snap
            Case 1
                Me.Top = Form1.Top + 34
                Me.Left = Form1.Right - Me.Width - 4
            Case 2
                Dim p As Point = Form1.GroupBox_RadiationPlot.PointToScreen(Form1.pbox_ScrollingScope.Location)
                Me.Top = p.Y + 4
                Me.Left = p.X + 4
        End Select
    End Sub


    ' --------------------------------------------------------------------- GET METER CPS
    Friend InputSlot As Int32
    Private MeterCounts As Int32
    Private MeterCPS_0 As Single = 0
    Private MeterCPS_DeadTimeCorrected As Single = 0
    Private MeterCPS_DeadTimeCorrected_Smoothed As Single = 0
    Private Const SPEED_SLOW As Single = 0.2
    Private Const SPEED_NORM As Single = 0.6
    Private Const SPEED_FAST As Single = 5
    Private m_kspeed As Single = SPEED_FAST
    Private AnalogUsh As Single = 0
    Private AnalogUrh As Single = 0
    Private AnalogPciL As Single = 0
    Private AnalogBqm3 As Single = 0

    Friend Sub ResetMeterValues()
        MeterCPS_DeadTimeCorrected_Smoothed = 0
    End Sub

    ' ------------------------------------------------------------------------------------------------------------
    '  called every 33.3 mS ( 30Hz )
    ' ------------------------------------------------------------------------------------------------------------
    Private NextTime As DateTime = DateTime.MinValue
    Private Sub MeterTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MeterTimer.Tick
        '
        ' ------------------------------------------------------------- GetDeltaCounts each second
        If Now >= NextTime Then
            ' ---------------------------------------
            If NextTime < Now Then NextTime = Now
            ' ---------------------------------------
            MeterCPS_0 = GetDeltaCounts()
            ' --------------------------------------- sync to next second
            NextTime = RoundUp(Now, 1)
        End If
        '
        ' ------------------------------------------------------------- DeadTime correction
        MeterCPS_DeadTimeCorrected = Form1.CorrectForDeadTime(MeterCPS_0)
        ' ------------------------------------------------------------- SMOOTING
        Dim speed As Single = MeterCPS_DeadTimeCorrected_Smoothed * 0.005F * m_kspeed
        Dim minspeed As Single = 0.0005F * m_kspeed
        Dim maxspeed As Single = 0.05F * m_kspeed
        If speed < minspeed Then speed = minspeed
        If speed > maxspeed Then speed = maxspeed
        SmoothValue(MeterCPS_DeadTimeCorrected_Smoothed, MeterCPS_DeadTimeCorrected, speed)
        ' ------------------------------------------------------------- MicroRoentgen and MicroSieverts
        AnalogUrh = Form1.CalcMicroRoentgens(MeterCPS_DeadTimeCorrected_Smoothed)
        AnalogUsh = Form1.CalcMicroSieverts(AnalogUrh)
        If AnalogUrh < 0.8 Then AnalogUrh = 0.8
        If AnalogUsh < 0.008 Then AnalogUsh = 0.008
        ' ------------------------------------------------------------- PicoCurie and Bequerels
        AnalogPciL = Form1.CalcPicoCurie(MeterCPS_DeadTimeCorrected_Smoothed)
        AnalogBqm3 = Form1.CalcBequerels(MeterCPS_DeadTimeCorrected_Smoothed)
        If AnalogPciL < 0.008 Then AnalogPciL = 0.008
        If AnalogBqm3 < 0.8 Then AnalogBqm3 = 0.8
        ' ------------------------------------------------------------- update analog meter
        Select Case m_ScaleType
            Case ScaleTypes.CpsLow, ScaleTypes.CpsMid, ScaleTypes.CpsHi
                AnalogMeter1.Value = MeterCPS_DeadTimeCorrected_Smoothed

            Case ScaleTypes.CpmLow, ScaleTypes.CpmMid, ScaleTypes.CpmHi
                AnalogMeter1.Value = MeterCPS_DeadTimeCorrected_Smoothed * 60

            Case ScaleTypes.ShLow, ScaleTypes.ShMid, ScaleTypes.ShHi
                AnalogMeter1.Value = AnalogUsh

            Case ScaleTypes.RhLow, ScaleTypes.RhMid
                AnalogMeter1.Value = AnalogUrh

            Case ScaleTypes.RhHi
                AnalogMeter1.Value = AnalogUrh / 1000

            Case ScaleTypes.CiLow, ScaleTypes.CiMid, ScaleTypes.CiHi
                AnalogMeter1.Value = AnalogPciL

            Case ScaleTypes.BqLow, ScaleTypes.BqMid, ScaleTypes.BqHi
                AnalogMeter1.Value = AnalogBqm3
        End Select
    End Sub

    Private Function GetDeltaCounts() As Int32
        Static oldc As Int32 = 99999
        '
        Dim newc As Int32
        newc = Slots.ReadSlot_Limited_65535(InputSlot)
        '
        If oldc = 99999 Then oldc = newc
        Dim c As Int32
        If newc >= oldc Then
            c = newc - oldc
        Else
            c = ((65535 - oldc) + newc + 1)
        End If
        If c < 0 Then c = 0
        oldc = newc
        Return c
    End Function

    Private Sub Form2_ResizeBegin(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeBegin
        Panel1.Visible = False
    End Sub
    Private Sub Form2_ResizeEnd(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeEnd
        SetAspectRatio()
        Panel1.Visible = True
    End Sub
    Private Sub SetAspectRatio()
        If Math.Abs(Width - OldSize.Width) <= Math.Abs(Height - OldSize.Height) Then
            Width = CInt((Height - Panel1.Height - 10) * MeterAspect)
        Else
            Height = AnalogMeter1.Height + Panel1.Height + 28
        End If
        OldSize = Me.Size
    End Sub

End Class